/*
JSget - The 2D Full Featured Game Engine in JavaScript/HTML5

Author: Nathan Mentley (NathanMentley@GMail.com)
Version: 0.1
Updated: 10-08-2011
Web Site: http://NathanMentley.com/JSget/
File Info: JSgExample.js contains an example gamestate class.
License: The Creative Commons Attribution-ShareAlike 3.0 Unported License

Full License Text:
	http://creativecommons.org/licenses/by-sa/3.0/legalcode

License Summary:
	You Are Free:
	to Share - to copy, distribute and transmit the work
	to Remix - to adapt the work
	To Profit - to make commercial use of the work

	Under the contidtions:
	Attribution — You must attribute the work in the manner specified by the author or
		licensor (but not in any way that suggests that they endorse you or your use
		of the work).
	Share Alike — If you alter, transform, or build upon this work, you may distribute the
		resulting work only under the same or similar license to this one.


	With the understanding that:
	Waiver — Any of the above conditions can be waived if you get permission from the
		copyright holder.
	Public Domain — Where the work or any of its elements is in the public domain under
		applicable law, that status is in no way affected by the license.
	Other Rights — In no way are any of the following rights affected by the license:
		Your fair dealing or fair use rights, or other applicable copyright exceptions
			and limitations;
		The author's moral rights;
		Rights other persons may have either in the work itself or in how the work is
			used, such as publicity or privacy rights.
*/

//JSget's Example Game State Class. Any class with these
// variables will work as a game state.
function JSgGameState_EXAMPLE(engine){
	this.prev = null;
	this.next = null;
	this.engine = engine;
	this.doRender = false;
	this.doLogic = false;

	this.myImage = new Image();
	this.myImage.src = 'test.jpg';

	this.init = function(){
		this.doRender = true;
		this.doLogic = true;
		this.i = 0;
	};
	this.deinit = function(){
		this.doRender = false;
		this.doLogic = false;
	};
	this.logic = function(key){
		if(this.engine.mouseClicked == true){
			this.engine.popState();
			this.engine.mouseClicked = false;
		}
		if(this.engine.isKeyDown(65))
			this.engine.pushState(new JSgGameState_EXAMPLE(this.engine, 8));
		this.i++;
		if(this.i > this.engine.WIDTH)
			this.i = 0;
	};
	this.render = function(){
		this.engine.drawImage(this.i,200,130,110,this.myImage);
	};
	this.pause = function(){
		this.doRender = false;
		this.doLogic = false;
	};
	this.unpause = function(){
		this.doRender = true;
		this.doLogic = true;
	};
}
